/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOPER                                                 */
/* Tabela : GRUPOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 11/04/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_GRUPOPER
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPOPER FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGROP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDGRUPOPER,0) <> NVL(:NEW.CDGRUPOPER,0)) OR
         (NVL(:OLD.DSGRUPOPER,0) <> NVL(:NEW.DSGRUPOPER,0)) OR
         (NVL(:OLD.IDUTCTRSENOP,0) <> NVL(:NEW.IDUTCTRSENOP,0)) OR
         (NVL(:OLD.DSSENHACAIXA,0) <> NVL(:NEW.DSSENHACAIXA,0)) THEN
         :NEW.DTULTATUGROP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPOPER', '', 'CDGRUPOPER='||:OLD.CDGRUPOPER||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPOPER MODIFY DTULTATUGROP DEFAULT SYSDATE
/

UPDATE GRUPOPER SET DTULTATUGROP = SYSDATE WHERE DTULTATUGROP IS NULL
/

