function Cus00200_ProdutosComPrecoDesatualizado_Controller(ScreenService, General, Parametros) {

	this.defaultValues = function (widget) {

		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
			widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL')+' | '+getLocalVar('NMFILIAL');
			widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
		}
		
		var relatorio = widget.getField('REPORT_NAME').dataSource.getFirstRow();
		Parametros.retornaDataProcessamento().then(function (data) {
			widget.currentRow.DTREFE = data;
			var defaultValue = {
				start: data,
				end: data
			};
			// var DTINTERVAL = widget.getField('DTINTERVAL');
			// DTINTERVAL.value(defaultValue);
			
			widget.currentRow.DTINICIAL = data;
			widget.currentRow.DTFINAL = data; 
			widget.currentRow.__report_name = relatorio.REPORT_NAME;
			widget.currentRow.REPORT_CODE = relatorio.REPORT_CODE;
		}, function (callback) {

		});

	};

	this.validacaoData = function (widget) {

		var dataInicial = moment(widget.currentRow.DTINICIAL, 'DD/MM/YYYY');
		var dataFinal = moment(widget.currentRow.DTFINAL, 'DD/MM/YYYY');
		var mensagem = ScreenService.i18n("A data final deve ser menor ou igual a data final.");

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};

	this.onChangeFilial = function(widget) {
		var grupservCheckbox = widget.getField('ALLCDGRUPSERV');
		var grupservField = widget.getField('NMGRUPSERV');

		grupservCheckbox.setValue('Y');
		grupservCheckbox.checked = true;
		General.toggleReadOnlySelect(grupservCheckbox, grupservField);

		this.onCangeGrupserv(widget);
	};

	this.onCangeGrupserv = function(widget){
		var servicosCheckbox = widget.getField('ALLCDSERVFILI');
		var servicosField = widget.getField('NMSERVICO');
		servicosCheckbox.setValue('Y');
		servicosCheckbox.checked = true;
		General.toggleReadOnlySelect(servicosCheckbox, servicosField);
	};

	this.verificaCheckboxTodos = function (currentRow) {

		if (currentRow.ALLCDSERVFILI == 'N') {
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else {
			currentRow.LISTASERV = 'REQUEST';
		}

		currentRow.LISTAGRUPSERV = this.retornaGrupServ(currentRow);
	};

	this.retornaGrupServ = function(currentRow) {
		if (currentRow.ALLCDGRUPSERV == 'N') {
			if (Array.isArray(currentRow.NMGRUPSERV)) {
				return currentRow.NMGRUPSERV.join('_');
			} else {
				return "";
			}
		} else {
			return 'T';
		}
	};

	this.onClickServico = function(field){
		var widget = field.widget;

		var filterData = {
			CDFILIAL : widget.currentRow.CDFILIAL || '',
			CDGRUPSERV : this.retornaGrupServ(widget.currentRow)
		};

		General.buildDataSourceFilter(field.dataSourceFilter, filterData);
		field.reload();
	};

	this.abreRelatorio = function (reportName, row, currentRow) {
		this.verificaCheckboxTodos(currentRow);
		General.openReport('cus_relatorio#/cus00200_produtos_com_preco_desatualizado', reportName, row);
	}.bind(this);

	this.validacaoCampos = function (widget, row) {
		var current = widget.currentRow;
		var reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    },
		    {
		        name: "txt",
		        value: "TXT"
		    }
		];

		var reportName = current.REPORT_NAME;
		if (widget.isValid() && this.validacaoData(widget)) {
			General.openReportPopup(widget, this.abreRelatorio, [reportName, row, current], reportFormats);
		}
	};
	
	this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || ''; 
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus00200_ProdutosComPrecoDesatualizado_Controller', Cus00200_ProdutosComPrecoDesatualizado_Controller);
});